//UmidukiSeisakujo EAR Archive
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	unsigned char		tmp[11];
	unsigned char		*buf;
	unsigned char		*filebuf;
	unsigned long		header_length = 0L;
	unsigned int		file_count = 0;
	unsigned long		file_ed = 0L;

	char				header_filename[12];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filesize = 0L;

	unsigned long		nowsize = 0L;

	unsigned int		i;

	printf( "UmidukiSeisakujo EAR Divider 060226 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: EARDIV <filename>\n" );
		return;
	}

	if( strncmpi( &av[1][strlen( av[1] ) - 3 ], "EAR", 3 ))
	{
		printf( "error: not EAR format.\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	//filesize
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	//file_count
	fread( tmp, 4, 1, in );
	file_count = *( unsigned long *)( tmp );
	printf( "file_count: %d\n", file_count );

	//Header size
	header_length = file_count * 0x18;
	printf( "header_length: %lu(%04lX)\n", header_length, header_length );

	//Read header
	buf = ( unsigned char * )calloc( 1, header_length );
	fread( buf, header_length, 1, in );

	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		memcpy( header_filename, &buf[i*0x18], 13 );

		header_filest = *( unsigned long *)( buf + ( i * 0x18 + 0x10 ));
		header_filesize = *( unsigned long *)( buf + ( i * 0x18 + 0x14 ));
		header_fileed = header_filest + header_filesize;

		printf( "%03d %-13s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( header_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );	//32k
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );
		printf( ".\n" );
		fclose( out );

		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );

end:;
	free( buf );
	fclose( in );

	return;
}
